#ifndef _COMMON_H
#define _COMMON_H

#include <stddef.h>
#include <inttypes.h>

#define BUFF_SIZE		1024
#define FILENAME_LEN	256
#define ERRORMSG_LEN	256

typedef enum
{
	OPCODE_RRQ   = 1,
    OPCODE_WRQ   = 2,
    OPCODE_DATA  = 3,
    OPCODE_ACK   = 4,
    OPCODE_ERROR = 5
} opcode;

typedef enum
{
	ACTION_UNKNOWN,
	ACTION_SEND,
	ACTION_RECEIVE
} action;

void make_rrq_frame(const char* filename, char* frame);
void make_wrq_frame(const char* filename, char* frame);
void make_data_frame(uint16_t blocknum, char* frame);
void make_ack_frame(uint16_t blocknum, char* frame);
void make_error_frame(uint16_t errorcode, const char* errormsg, char* frame);

void parse_frame(const char* frame, uint16_t* first, uint16_t* second);

int poll_socket(int sck, int timeout);

#endif /* _COMMON_H */

